#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const N = 100'000;
    long long const A = 1000'000'000'000;

    int n = inf.readInt(1, N, "n");
    int g = validator.group().size() ? atoi(validator.group().c_str()) : 0;
    if (g == 1) ensuref(n <= 2, "Group 1 condition n <= 2 unsatisfied, n = %d", n);
    if (g == 3) ensuref(n <= 3, "Group 1 condition n <= 2 unsatisfied, n = %d", n);
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        int x = inf.readLong(1, A, format("a_%d", i + 1));
        inf.readSpace();
        int y = inf.readLong(1, A, format("b_%d", i + 1));
        inf.readEoln();

        if (g == 2)
            ensuref(x == y, "Group 2 condition x = y unsatisfied, x = %d, y = %d", x, y);
        if (g == 4) {
            ensuref((x & (x - 1)) == 0, "Group 4 condition x = 2^k unsatisfied, x = %d", x);
            ensuref((y & (y - 1)) == 0, "Group 4 condition y = 2^k unsatisfied, y = %d", y);
        }
    }

    inf.readEof();

}